diff --git a/test/unit/commands/doctor_dependencies_test.rb b/test/unit/commands/doctor_dependencies_test.rb
new file mode 100644
index 000000000..aa52fcbdc
--- /dev/null
+++ b/test/unit/commands/doctor_dependencies_test.rb
@@ -0,0 +1,48 @@
+# frozen_string_literal: true
+
+require_relative "../../test_helper"
+require "hive/commands/doctor"
+
+# Wiring between `hive doctor` and Hive::Dependencies (plan: U5). The actual
+# probe logic is covered in test/unit/dependencies_test.rb; here we pin that
+# `hive doctor` includes dependency rows by default and omits them when
+# `dependencies: false` (the path `hive init`'s non-fatal preflight uses).
+class DoctorDependenciesTest < Minitest::Test
+  def stub_dependencies(rows)
+    singleton = Hive::Dependencies.singleton_class
+    singleton.send(:alias_method, :__deps_orig_check, :check)
+    singleton.send(:define_method, :check) { rows }
+    yield
+  ensure
+    singleton.send(:alias_method, :check, :__deps_orig_check)
+    singleton.send(:remove_method, :__deps_orig_check)
+  end
+
+  def base_config
+    { "brainstorm" => { "agent" => "claude" }, "plan" => { "agent" => "claude" } }
+  end
+
+  def test_doctor_includes_dependency_rows_by_default
+    row = { kind: "dependency", label: "dependency/jq", agent: "jq",
+            configured_skill: ">= 1.6", skill: "jq", status: "missing",
+            version: nil, message: "not found on PATH", hint: "brew install jq" }
+    stub_dependencies([ row ]) do
+      doctor = Hive::Commands::Doctor.new(config: base_config, project_root: nil, output: StringIO.new)
+      doctor.call
+      deps = doctor.rows.select { |r| r[:kind] == "dependency" }
+      assert_equal 1, deps.length
+      assert_equal "dependency/jq", deps.first[:label]
+    end
+  end
+
+  def test_doctor_omits_dependency_rows_when_disabled
+    row = { kind: "dependency", label: "dependency/jq", agent: "jq",
+            configured_skill: ">= 1.6", skill: "jq", status: "missing",
+            version: nil, message: "not found", hint: "brew install jq" }
+    stub_dependencies([ row ]) do
+      doctor = Hive::Commands::Doctor.new(config: base_config, project_root: nil, output: StringIO.new, dependencies: false)
+      doctor.call
+      assert_empty doctor.rows.select { |r| r[:kind] == "dependency" }
+    end
+  end
+end
diff --git a/test/unit/commands/doctor_test.rb b/test/unit/commands/doctor_test.rb
index e54f4fd5f..c770b8f31 100644
--- a/test/unit/commands/doctor_test.rb
+++ b/test/unit/commands/doctor_test.rb
@@ -7,6 +7,22 @@ require "hive/commands/doctor"
 class HiveCommandsDoctorTest < Minitest::Test
   include HiveTestHelper
 
+  # The dependency check probes real binaries (git/bash/claude/gh/jq) on PATH,
+  # which is environment-dependent. Existing doctor tests exercise the skill
+  # and reviewer probes, so stub the dependency check to return no rows here
+  # and cover Hive::Dependencies directly in test/unit/dependencies_test.rb.
+  def setup
+    singleton = Hive::Dependencies.singleton_class
+    singleton.send(:alias_method, :__deps_orig_check, :check)
+    singleton.send(:define_method, :check) { [] }
+  end
+
+  def teardown
+    singleton = Hive::Dependencies.singleton_class
+    singleton.send(:alias_method, :check, :__deps_orig_check)
+    singleton.send(:remove_method, :__deps_orig_check)
+  end
+
   def with_fake_home
     with_tmp_dir do |dir|
       old = ENV["HOME"]
diff --git a/test/unit/commands/init/prompts_test.rb b/test/unit/commands/init/prompts_test.rb
index 734b955d9..94e260f8e 100644
--- a/test/unit/commands/init/prompts_test.rb
+++ b/test/unit/commands/init/prompts_test.rb
@@ -46,7 +46,8 @@ class InitPromptsTest < Minitest::Test
       "timeouts" => Hive::Commands::Init::Prompts::LIMIT_KEYS.each_with_object({}) do |k, h|
         h[k] = Hive::Config::DEFAULTS["timeout_sec"][k]
       end,
-      "daemon_enabled" => true
+      "daemon_enabled" => true,
+      "daemon_service_enable_start" => false
     }
   end
 
@@ -59,11 +60,13 @@ class InitPromptsTest < Minitest::Test
   #         open_pr, finalize, review_ci, review_triage, review_fix,
   #         review_browser)
   #  14. daemon enable Y/n            (added under ADR-024)
-  #  15. confirmation Y/n
+  #  15. daemon-service enable+start y/N (added under install U4)
+  #  16. confirmation Y/n
   # Each line is one answer; blank line = accept default.
   def interactive_input(planning: "", development: "", reviewers: "",
-                        triage_bias: "", limits: ([ "" ] * 9), daemon: "", confirm: "")
-    [ planning, development, reviewers, triage_bias, *limits, daemon, confirm ].map { |a| "#{a}\n" }.join
+                        triage_bias: "", limits: ([ "" ] * 9), daemon: "",
+                        daemon_service: "", confirm: "")
+    [ planning, development, reviewers, triage_bias, *limits, daemon, daemon_service, confirm ].map { |a| "#{a}\n" }.join
   end
 
   # --- non-TTY: short-circuit to defaults ----------------------------------
@@ -141,7 +144,7 @@ class InitPromptsTest < Minitest::Test
     # 16 reads total: planning (invalid + retry) + dev + reviewers
     # + triage bias + 9 limits + daemon + confirm. Each blank line
     # accepts the default.
-    raw = ([ "nonexistent", "claude" ] + ([ "" ] * 14)).join("\n") + "\n"
+    raw = ([ "nonexistent", "claude" ] + ([ "" ] * 15)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(raw)
     answers = prompts.collect
     assert_equal "claude", answers["planning_agent"]
@@ -149,7 +152,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_planning_agent_index_out_of_range_reprompts
-    raw = ([ "7", "claude" ] + ([ "" ] * 14)).join("\n") + "\n"
+    raw = ([ "7", "claude" ] + ([ "" ] * 15)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(raw)
     answers = prompts.collect
     assert_equal "claude", answers["planning_agent"]
@@ -189,7 +192,7 @@ class InitPromptsTest < Minitest::Test
     # Build the input manually since interactive_input doesn't allow
     # multi-line reviewer answers cleanly. Trailing values are triage
     # bias, nine limits, daemon, and confirm.
-    input = ([ "", "", "7", "1,2" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "7", "1,2" ] + ([ "" ] * 13)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review codex-ce-code-review], answers["enabled_reviewers"]
@@ -197,7 +200,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_reviewers_unknown_name_reprompts
-    input = ([ "", "", "nope", "1" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "nope", "1" ] + ([ "" ] * 13)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review], answers["enabled_reviewers"]
@@ -231,7 +234,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_interactive_triage_bias_unknown_reprompts
-    input = ([ "", "", "", "bad", "2" ] + ([ "" ] * 11)).join("\n") + "\n"
+    input = ([ "", "", "", "bad", "2" ] + ([ "" ] * 12)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal "safetyist", answers["triage_bias"]
@@ -278,7 +281,7 @@ class InitPromptsTest < Minitest::Test
   def test_interactive_limits_zero_budget_reprompts
     # First answer 0,300 fails validation → re-prompt; second answer 10,600 accepted.
     # Trailing pair is daemon + confirm (both blank → daemon enabled, confirm yes).
-    input = ([ "", "", "", "", "0,300", "10,600" ] + ([ "" ] * 10)).join("\n") + "\n"
+    input = ([ "", "", "", "", "0,300", "10,600" ] + ([ "" ] * 11)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal 10, answers["budgets"]["brainstorm"]
@@ -288,7 +291,7 @@ class InitPromptsTest < Minitest::Test
 
   def test_interactive_limits_malformed_format_reprompts
     # "30" without comma fails the <budget>,<timeout> shape → re-prompt
-    input = ([ "", "", "", "", "30", "30,900" ] + ([ "" ] * 10)).join("\n") + "\n"
+    input = ([ "", "", "", "", "30", "30,900" ] + ([ "" ] * 11)).join("\n") + "\n"
     prompts, output = make_prompts(input)
     answers = prompts.collect
     assert_equal 30, answers["budgets"]["brainstorm"]
@@ -465,7 +468,7 @@ class InitPromptsTest < Minitest::Test
     # Truncate the input transcript right before confirmation. read_line
     # must distinguish nil-from-gets (EOF) from an empty line and bubble
     # Aborted up the stack rather than silently confirming.
-    inputs = ([ "" ] * 14).join("\n") + "\n"  # 14 blank reads, then EOF
+    inputs = ([ "" ] * 15).join("\n") + "\n"  # 15 blank reads, then EOF
     prompts, _output, _summary = make_prompts(inputs)
     assert_raises(Hive::Commands::Init::Prompts::Aborted) { prompts.collect }
   end
@@ -494,7 +497,7 @@ class InitPromptsTest < Minitest::Test
   # validate_reviewers! rejects on the next `hive run`. Re-prompt instead.
   def test_reviewers_comma_only_reprompts
     # Trailing values are triage bias, nine limits, daemon, and confirm.
-    input = ([ "", "", ",", "1" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", ",", "1" ] + ([ "" ] * 13)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[claude-ce-code-review], answers["enabled_reviewers"]
@@ -502,7 +505,7 @@ class InitPromptsTest < Minitest::Test
   end
 
   def test_reviewers_whitespace_only_reprompts
-    input = ([ "", "", "  ,  ,  ", "2" ] + ([ "" ] * 12)).join("\n") + "\n"
+    input = ([ "", "", "  ,  ,  ", "2" ] + ([ "" ] * 13)).join("\n") + "\n"
     prompts, output, _summary = make_prompts(input)
     answers = prompts.collect
     assert_equal %w[codex-ce-code-review], answers["enabled_reviewers"]
diff --git a/test/unit/commands/uninstall_test.rb b/test/unit/commands/uninstall_test.rb
new file mode 100644
index 000000000..fc4c09192
--- /dev/null
+++ b/test/unit/commands/uninstall_test.rb
@@ -0,0 +1,134 @@
+# frozen_string_literal: true
+
+require_relative "../../test_helper"
+require "hive/commands/uninstall"
+
+# `hive uninstall` safety contracts (plan: U3): binary removal per channel,
+# completed-work preservation (8-done survives), non-interactive --purge,
+# and interactive confirmation.
+class UninstallCommandTest < Minitest::Test
+  ENV_VARS = %w[HIVE_HOME XDG_CONFIG_HOME XDG_STATE_HOME XDG_CACHE_HOME HOME HIVE_BIN_DIR].freeze
+
+  def with_clean_env
+    saved = {}
+    ENV_VARS.each { |v| saved[v] = ENV[v] }
+    ENV_VARS.each { |v| ENV.delete(v) }
+    yield
+  ensure
+    saved.each { |v, val| val.nil? ? ENV.delete(v) : ENV[v] = val }
+  end
+
+  def test_preserve_completed_work_keeps_8_done
+    Dir.mktmpdir("hive-uninstall") do |dir|
+      state = File.join(dir, ".hive-state")
+      inbox = File.join(state, "stages", "1-inbox", "task-a")
+      done = File.join(state, "stages", "8-done", "task-b")
+      config = File.join(state, "config.yml")
+      FileUtils.mkdir_p(inbox)
+      FileUtils.mkdir_p(done)
+      File.write(config, "x")
+      File.write(File.join(done, "summary.md"), "merged")
+
+      Hive::Commands::Uninstall.new(purge: true).preserve_completed_work(state)
+
+      refute File.directory?(File.join(state, "stages", "1-inbox")), "non-done stages removed"
+      refute File.exist?(config), "config.yml removed"
+      assert File.directory?(done), "8-done preserved"
+      assert File.exist?(File.join(done, "summary.md")), "completed artifact preserved"
+    end
+  end
+
+  def test_remove_binary_bash_channel_deletes_binary
+    Dir.mktmpdir("hive-uninstall") do |dir|
+      with_clean_env do
+        ENV["HIVE_BIN_DIR"] = dir
+        bin = File.join(dir, "hive")
+        File.write(bin, "#!/bin/sh\n")
+        assert File.exist?(bin)
+
+        Hive::Commands::Uninstall.new(purge: true, channel: "bash").remove_binary!
+        refute File.exist?(bin), "bash-installed binary removed"
+      end
+    end
+  end
+
+  def test_call_purge_removes_config_and_project_state_preserving_done
+    Dir.mktmpdir("hive-uninstall") do |root|
+      with_clean_env do
+        ENV["HIVE_HOME"] = File.join(root, "config-home")
+        ENV["HOME"] = File.join(root, "home")
+
+        # A registered project with in-flight and completed work.
+        project = File.join(root, "project")
+        state = File.join(project, ".hive-state")
+        FileUtils.mkdir_p(File.join(state, "stages", "4-execute", "task"))
+        FileUtils.mkdir_p(File.join(state, "stages", "8-done", "merged"))
+        Hive::Config.register_project(name: "proj", path: project)
+
+        Hive::Install.record_install_channel!("bash")
+
+        Hive::Commands::Uninstall.new(purge: true, channel: "bash").call
+
+        refute File.exist?(Hive::Config.global_config_path), "global config removed"
+        assert File.directory?(File.join(state, "stages", "8-done", "merged")), "completed work preserved"
+        refute File.directory?(File.join(state, "stages", "4-execute")), "in-flight work removed"
+      end
+    end
+  end
+
+  def test_interactive_abort_raises_and_leaves_state
+    Dir.mktmpdir("hive-uninstall") do |dir|
+      with_clean_env do
+        ENV["HIVE_HOME"] = File.join(dir, "config-home")
+        ENV["HOME"] = File.join(dir, "home")
+        FileUtils.mkdir_p(ENV["HIVE_HOME"])
+        File.write(Hive::Config.global_config_path, "registered_projects: []\n")
+
+        input = StringIO.new("n\n")
+        input.define_singleton_method(:tty?) { true }
+        output = StringIO.new
+
+        assert_raises(Hive::Error) do
+          Hive::Commands::Uninstall.new(channel: "brew", input: input, output: output).call
+        end
+        assert File.exist?(Hive::Config.global_config_path), "abort must not delete config"
+      end
+    end
+  end
+
+  def test_remove_global_config_removes_empty_xdg_dirs
+    Dir.mktmpdir("hive-uninstall") do |root|
+      with_clean_env do
+        ENV["XDG_CONFIG_HOME"] = File.join(root, "config")
+        ENV["XDG_STATE_HOME"]  = File.join(root, "state")
+        ENV["XDG_CACHE_HOME"]  = File.join(root, "cache")
+        ENV["HOME"] = File.join(root, "home")
+
+        FileUtils.mkdir_p(Hive::Paths.config_dir)
+        File.write(Hive::Config.global_config_path, "registered_projects: []\n")
+        FileUtils.mkdir_p(Hive::Paths.state_dir)
+        FileUtils.mkdir_p(Hive::Paths.cache_dir)
+
+        Hive::Commands::Uninstall.new(purge: true, channel: "brew").remove_global_config!
+
+        refute File.exist?(Hive::Paths.config_dir), "empty config dir must be removed"
+        refute File.exist?(Hive::Paths.state_dir), "empty state dir must be removed"
+        refute File.exist?(Hive::Paths.cache_dir), "empty cache dir must be removed"
+      end
+    end
+  end
+
+  def test_brew_channel_shells_out_to_brew_uninstall
+    captured = nil
+    runner = ->(cmd) { captured = cmd }
+    Hive::Commands::Uninstall.new(purge: true, channel: "brew", runner: runner).remove_binary!
+    assert_equal %w[brew uninstall hive], captured
+  end
+
+  def test_aur_channel_shells_out_to_yay_remove
+    captured = nil
+    runner = ->(cmd) { captured = cmd }
+    Hive::Commands::Uninstall.new(purge: true, channel: "aur", runner: runner).remove_binary!
+    assert_equal %w[yay -R hive-bin], captured
+  end
+end
diff --git a/test/unit/commands/update_test.rb b/test/unit/commands/update_test.rb
new file mode 100644
index 000000000..e82d074da
--- /dev/null
+++ b/test/unit/commands/update_test.rb
@@ -0,0 +1,54 @@
+# frozen_string_literal: true
+
+require_relative "../../test_helper"
+require "hive/commands/update"
+
+# `hive update` channel → updater command assembly (plan: U3). No network —
+# the runner is injected and command arrays are asserted directly.
+class UpdateCommandTest < Minitest::Test
+  def test_update_command_for_brew
+    cmd = Hive::Commands::Update.new.update_command("brew")
+    assert_equal %w[brew upgrade hive], cmd
+  end
+
+  def test_update_command_for_aur
+    cmd = Hive::Commands::Update.new.update_command("aur")
+    assert_equal %w[yay -Syu hive-bin], cmd
+  end
+
+  def test_update_command_for_bash_reruns_installer
+    cmd = Hive::Commands::Update.new.update_command("bash")
+    assert_match(/curl -fsSL .*install\.sh \| bash/, cmd)
+  end
+
+  def test_call_unknown_channel_raises
+    err = assert_raises(Hive::Error) do
+      Hive::Commands::Update.new(channel: "nix").call
+    end
+    assert_match(/unknown install channel/, err.message)
+  end
+
+  def test_call_nil_channel_raises
+    err = assert_raises(Hive::Error) do
+      Hive::Commands::Update.new(channel: nil).call
+    end
+    assert_match(/install channel unknown/, err.message)
+  end
+
+  def test_call_invokes_runner_with_assembled_command
+    captured = nil
+    runner = ->(cmd) { captured = cmd }
+    Hive::Commands::Update.new(channel: "brew", runner: runner).call
+    assert_equal %w[brew upgrade hive], captured
+  end
+
+  def test_call_json_reports_channel
+    runner = ->(_cmd) { true }
+    out, = capture_io do
+      Hive::Commands::Update.new(channel: "aur", runner: runner, json: true).call
+    end
+    payload = JSON.parse(out)
+    assert_equal true, payload["ok"]
+    assert_equal "aur", payload["channel"]
+  end
+end
diff --git a/test/unit/dependencies_test.rb b/test/unit/dependencies_test.rb
new file mode 100644
index 000000000..a86ced8b5
--- /dev/null
+++ b/test/unit/dependencies_test.rb
@@ -0,0 +1,97 @@
+# frozen_string_literal: true
+
+require_relative "../test_helper"
+require "hive/dependencies"
+
+# Runtime dependency detection (plan: U5). Uses fake binaries on PATH so the
+# version probes are hermetic — no dependency on the host's real tools.
+class DependenciesTest < Minitest::Test
+  include HiveTestHelper
+
+  def with_fake_bin_dir
+    with_tmp_dir do |dir|
+      old_path = ENV["PATH"]
+      ENV["PATH"] = "#{dir}:#{old_path}"
+      yield dir
+    ensure
+      ENV["PATH"] = old_path
+    end
+  end
+
+  def write_bin(dir, name, output, exit_status: 0)
+    path = File.join(dir, name)
+    File.write(path, <<~SH)
+      #!/usr/bin/env bash
+      echo "#{output}"
+      exit #{exit_status}
+    SH
+    File.chmod(0o755, path)
+    path
+  end
+
+  def test_check_returns_all_five_required_tools
+    rows = Hive::Dependencies.check
+    names = rows.map { |r| r[:agent] }.sort
+    assert_equal %w[bash claude gh git jq], names
+  end
+
+  def test_present_tool_reports_present_with_version
+    with_fake_bin_dir do |dir|
+      write_bin(dir, "jq", "jq-1.7.1")
+      row = Hive::Dependencies.check_one(Hive::Dependencies::TOOLS.find { |t| t["name"] == "jq" })
+      assert_equal "present", row[:status]
+      assert_equal "1.7.1", row[:version]
+    end
+  end
+
+  def test_two_component_version_reports_present_not_missing
+    # jq 1.6 (Ubuntu 22.04 default) prints `jq-1.6` — a two-component
+    # version. detect_version must accept it as present rather than failing
+    # the three-component regex and reporting the tier-1 default as missing.
+    with_fake_bin_dir do |dir|
+      write_bin(dir, "jq", "jq-1.6")
+      row = Hive::Dependencies.check_one(Hive::Dependencies::TOOLS.find { |t| t["name"] == "jq" })
+      assert_equal "present", row[:status]
+      assert_equal "1.6", row[:version]
+    end
+  end
+
+  def test_missing_tool_reports_missing_with_hint
+    # A tool that is definitely not on PATH: use a unique name by temporarily
+    # pointing detect_version at a nonexistent binary via a one-off tool hash.
+    tool = { "name" => "definitely-not-a-real-tool-#{Process.pid}", "min_version" => "1.0.0",
+             "flag" => "--version", "hints" => { "default" => "install it" } }
+    row = Hive::Dependencies.check_one(tool)
+    assert_equal "missing", row[:status]
+    assert_equal "install it", row[:hint]
+  end
+
+  def test_version_too_old_reports_hint
+    with_fake_bin_dir do |dir|
+      write_bin(dir, "jq", "jq-1.5.0")
+      row = Hive::Dependencies.check_one(Hive::Dependencies::TOOLS.find { |t| t["name"] == "jq" })
+      assert_equal "version_too_old", row[:status]
+      assert_equal "1.5.0", row[:version]
+      assert row[:hint], "old version must carry an install hint"
+    end
+  end
+
+  def test_detect_version_returns_nil_on_failure
+    with_fake_bin_dir do |dir|
+      write_bin(dir, "broken", "oops", exit_status: 1)
+      assert_nil Hive::Dependencies.detect_version("broken", "--version")
+    end
+  end
+
+  def test_below_min_compares_version_tuples
+    assert Hive::Dependencies.below_min?("2.39.0", "2.40.0")
+    refute Hive::Dependencies.below_min?("2.40.0", "2.40.0")
+    refute Hive::Dependencies.below_min?("3.0.0", "2.40.0")
+  end
+
+  def test_hint_falls_back_to_default
+    tool = { "hints" => { "macos" => "brew install x", "default" => "install x" } }
+    hint = Hive::Dependencies.hint(tool)
+    assert [ "brew install x", "install x" ].include?(hint)
+  end
+end
diff --git a/test/unit/install_script_test.rb b/test/unit/install_script_test.rb
new file mode 100644
index 000000000..ba95e6037
--- /dev/null
+++ b/test/unit/install_script_test.rb
@@ -0,0 +1,39 @@
+# frozen_string_literal: true
+
+require_relative "../test_helper"
+require "open3"
+
+# install.sh (plan: U8) shell-logic smoke tests. No network: exercises the
+# dry-run path and syntax validity, plus the checksum fail-closed branch via a
+# minimal local mock of the download step.
+class InstallScriptTest < Minitest::Test
+  ROOT = File.expand_path("../..", __dir__)
+  INSTALL_SH = File.join(ROOT, "install.sh")
+
+  def test_script_is_posix_syntax_valid
+    out, err, status = Open3.capture3("sh", "-n", INSTALL_SH)
+    assert status.success?, "install.sh must pass sh -n: #{err}"
+    assert_equal "", out
+  end
+
+  def test_dry_run_resolves_target_and_reports_dependencies
+    Dir.mktmpdir("hive-install") do |home|
+      env = { "HOME" => home, "HIVE_INSTALL_DRY_RUN" => "1", "HIVE_BIN_DIR" => File.join(home, "bin") }
+      out, _err, status = Open3.capture3(env, "sh", INSTALL_SH)
+      assert status.success?
+      assert_includes out, "dry-run"
+      assert_includes out, "would install"
+      assert_includes out, "checking required runtime tools"
+    end
+  end
+
+  def test_dry_run_does_not_download_or_write_channel
+    Dir.mktmpdir("hive-install") do |home|
+      env = { "HOME" => home, "HIVE_INSTALL_DRY_RUN" => "1", "HIVE_BIN_DIR" => File.join(home, "bin") }
+      Open3.capture3(env, "sh", INSTALL_SH)
+      refute File.exist?(File.join(home, ".config", "hive", "install-channel")),
+             "dry-run must not record the install channel"
+      refute File.exist?(File.join(home, "bin", "hive")), "dry-run must not install a binary"
+    end
+  end
+end
diff --git a/test/unit/install_test.rb b/test/unit/install_test.rb
new file mode 100644
index 000000000..2bf0859ad
--- /dev/null
+++ b/test/unit/install_test.rb
@@ -0,0 +1,77 @@
+# frozen_string_literal: true
+
+require_relative "../test_helper"
+require "hive/install"
+
+# Install-channel bookkeeping + command-name resolution (plan: U3).
+class InstallTest < Minitest::Test
+  ENV_VARS = %w[HIVE_HOME XDG_CONFIG_HOME HOME HIVE_BIN_DIR HIVE_COMMAND_NAME].freeze
+
+  def with_clean_env
+    saved = {}
+    ENV_VARS.each { |v| saved[v] = ENV[v] }
+    ENV_VARS.each { |v| ENV.delete(v) }
+    yield
+  ensure
+    saved.each { |v, val| val.nil? ? ENV.delete(v) : ENV[v] = val }
+  end
+
+  def test_install_channel_round_trips
+    Dir.mktmpdir("hive-install") do |dir|
+      with_clean_env do
+        ENV["HIVE_HOME"] = dir
+        assert_nil Hive::Install.install_channel
+        Hive::Install.record_install_channel!("brew")
+        assert_equal "brew", Hive::Install.install_channel
+        Hive::Install.clear_install_channel!
+        assert_nil Hive::Install.install_channel
+      end
+    end
+  end
+
+  def test_bin_dir_defaults_to_local_bin
+    Dir.mktmpdir("hive-home") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        assert_equal File.join(home, ".local/bin"), Hive::Install.bin_dir
+      end
+    end
+  end
+
+  def test_bin_dir_honours_override
+    with_clean_env do
+      ENV["HIVE_BIN_DIR"] = "/opt/custom/bin"
+      assert_equal "/opt/custom/bin", Hive::Install.bin_dir
+    end
+  end
+
+  def test_command_name_defaults_to_hive
+    with_clean_env do
+      assert_equal "hive", Hive::Install.command_name
+      refute Hive::Install.hv_fallback?
+    end
+  end
+
+  def test_command_name_honours_hv_fallback
+    with_clean_env do
+      ENV["HIVE_COMMAND_NAME"] = "hv"
+      assert_equal "hv", Hive::Install.command_name
+      assert Hive::Install.hv_fallback?
+    end
+  end
+
+  def test_command_name_reads_recorded_value
+    Dir.mktmpdir("hive-install") do |dir|
+      with_clean_env do
+        ENV["HIVE_HOME"] = dir
+        Hive::Install.record_command_name!("hv")
+        assert_equal "hv", Hive::Install.command_name
+        assert Hive::Install.hv_fallback?
+        assert_equal File.join(dir, "command-name"), Hive::Install.command_name_path
+
+        Hive::Install.clear_command_name!
+        assert_equal "hive", Hive::Install.command_name
+      end
+    end
+  end
+end
diff --git a/test/unit/paths_test.rb b/test/unit/paths_test.rb
new file mode 100644
index 000000000..146ad3151
--- /dev/null
+++ b/test/unit/paths_test.rb
@@ -0,0 +1,136 @@
+# frozen_string_literal: true
+
+require_relative "../test_helper"
+require "hive/paths"
+require "hive/config"
+
+# XDG layout resolver (plan: install/packaging U2).
+#
+# Pins the HIVE_HOME-collapse contract (legacy override wins and collapses
+# all four dirs to one base), the XDG_* override resolution, the default
+# fallbacks, and the one-way legacy migration shim.
+class PathsTest < Minitest::Test
+  ENV_VARS = %w[HIVE_HOME XDG_CONFIG_HOME XDG_DATA_HOME XDG_STATE_HOME XDG_CACHE_HOME HOME].freeze
+
+  def with_clean_env
+    saved = {}
+    ENV_VARS.each { |v| saved[v] = ENV[v] }
+    ENV_VARS.each { |v| ENV.delete(v) }
+    yield
+  ensure
+    saved.each { |v, val| val.nil? ? ENV.delete(v) : ENV[v] = val }
+  end
+
+  def reset_migration_flag!
+    Hive::Config.instance_variable_set(:@__legacy_migration_attempted, nil)
+  end
+
+  def test_home_override_treats_empty_string_as_unset
+    with_clean_env do
+      ENV["HIVE_HOME"] = ""
+      assert_nil Hive::Paths.home_override
+    end
+  end
+
+  def test_home_override_wins_and_collapses_all_dirs
+    with_clean_env do
+      ENV["HIVE_HOME"] = "/tmp/hive-base"
+      assert_equal "/tmp/hive-base", Hive::Paths.config_dir
+      assert_equal "/tmp/hive-base", Hive::Paths.data_dir
+      assert_equal "/tmp/hive-base", Hive::Paths.state_dir
+      assert_equal "/tmp/hive-base", Hive::Paths.cache_dir
+    end
+  end
+
+  def test_xdg_overrides_win_when_home_unset
+    with_clean_env do
+      ENV["HOME"] = "/tmp/fake-home"
+      ENV["XDG_CONFIG_HOME"] = "/tmp/xdg-config"
+      ENV["XDG_STATE_HOME"] = "/tmp/xdg-state"
+      assert_equal "/tmp/xdg-config/hive", Hive::Paths.config_dir
+      assert_equal "/tmp/xdg-state/hive", Hive::Paths.state_dir
+      # data/cache fall back to their XDG spec defaults when unset.
+      assert_equal "/tmp/fake-home/.local/share/hive", Hive::Paths.data_dir
+      assert_equal "/tmp/fake-home/.cache/hive", Hive::Paths.cache_dir
+    end
+  end
+
+  def test_defaults_resolve_to_absolute_xdg_paths
+    with_clean_env do
+      ENV["HOME"] = "/tmp/fake-home"
+      assert_equal "/tmp/fake-home/.config/hive", Hive::Paths.config_dir
+      assert_equal "/tmp/fake-home/.local/share/hive", Hive::Paths.data_dir
+      assert_equal "/tmp/fake-home/.local/state/hive", Hive::Paths.state_dir
+      assert_equal "/tmp/fake-home/.cache/hive", Hive::Paths.cache_dir
+    end
+  end
+
+  def test_legacy_home_points_at_dev_hive
+    with_clean_env do
+      ENV["HOME"] = "/tmp/fake-home"
+      assert_equal "/tmp/fake-home/Dev/hive", Hive::Paths.legacy_home
+      assert_equal "/tmp/fake-home/Dev/hive/config.yml", Hive::Paths.legacy_config_path
+    end
+  end
+
+  def test_migrate_legacy_home_copies_but_never_deletes
+    Dir.mktmpdir("hive-home") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        reset_migration_flag!
+
+        legacy = File.join(home, "Dev", "hive", "config.yml")
+        FileUtils.mkdir_p(File.dirname(legacy))
+        File.write(legacy, "registered_projects: []\n")
+
+        _out, err = capture_io { Hive::Config.migrate_legacy_home! }
+
+        target = File.join(home, ".config", "hive", "config.yml")
+        assert File.exist?(target), "expected target created at #{target}"
+        assert File.exist?(legacy), "legacy file must never be deleted"
+        assert_match(/migrated global config/, err)
+      end
+    end
+  end
+
+  def test_migrate_legacy_home_skips_when_target_exists
+    Dir.mktmpdir("hive-home") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        reset_migration_flag!
+
+        legacy = File.join(home, "Dev", "hive", "config.yml")
+        target = File.join(home, ".config", "hive", "config.yml")
+        FileUtils.mkdir_p(File.dirname(legacy))
+        FileUtils.mkdir_p(File.dirname(target))
+        File.write(legacy, "legacy\n")
+        File.write(target, "current\n")
+
+        _out, err = capture_io { Hive::Config.migrate_legacy_home! }
+
+        assert_equal "current\n", File.read(target), "target must not be overwritten"
+        refute_match(/migrated/, err)
+      end
+    end
+  end
+
+  def test_migrate_legacy_home_skips_when_home_explicitly_set
+    Dir.mktmpdir("hive-home") do |home|
+      with_clean_env do
+        ENV["HOME"] = home
+        ENV["HIVE_HOME"] = File.join(home, "explicit")
+        reset_migration_flag!
+
+        legacy = File.join(home, "Dev", "hive", "config.yml")
+        FileUtils.mkdir_p(File.dirname(legacy))
+        File.write(legacy, "legacy\n")
+
+        _out, err = capture_io { Hive::Config.migrate_legacy_home! }
+
+        assert_equal "", err, "no migration when HIVE_HOME is set"
+        target = File.join(home, "explicit", "config.yml")
+        refute File.exist?(target), "no target written when HIVE_HOME is set"
+      end
+    end
+  end
+end
